package com.ubsidi.menu.storageutils;

import androidx.room.DatabaseConfiguration;
import androidx.room.InvalidationTracker;
import androidx.room.RoomOpenHelper;
import androidx.room.RoomOpenHelper.Delegate;
import androidx.room.RoomOpenHelper.ValidationResult;
import androidx.room.util.DBUtil;
import androidx.room.util.TableInfo;
import androidx.room.util.TableInfo.Column;
import androidx.room.util.TableInfo.ForeignKey;
import androidx.room.util.TableInfo.Index;
import androidx.sqlite.db.SupportSQLiteDatabase;
import androidx.sqlite.db.SupportSQLiteOpenHelper;
import androidx.sqlite.db.SupportSQLiteOpenHelper.Callback;
import androidx.sqlite.db.SupportSQLiteOpenHelper.Configuration;
import com.ubsidi.menu.dao.CommissionDao;
import com.ubsidi.menu.dao.CommissionDao_Impl;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

@SuppressWarnings({"unchecked", "deprecation"})
public final class AppDatabase_Impl extends AppDatabase {
  private volatile CommissionDao _commissionDao;

  @Override
  protected SupportSQLiteOpenHelper createOpenHelper(DatabaseConfiguration configuration) {
    final SupportSQLiteOpenHelper.Callback _openCallback = new RoomOpenHelper(configuration, new RoomOpenHelper.Delegate(1) {
      @Override
      public void createAllTables(SupportSQLiteDatabase _db) {
        _db.execSQL("CREATE TABLE IF NOT EXISTS `CardBrandCommission` (`id` INTEGER NOT NULL, `card_brand_id` INTEGER NOT NULL, `business_id` INTEGER NOT NULL, `stripe_percentage` INTEGER NOT NULL, `stripe_fixed` INTEGER NOT NULL, `other` INTEGER NOT NULL, `created_at` TEXT, `brand_name` TEXT, PRIMARY KEY(`id`))");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `CountryCommission` (`id` INTEGER NOT NULL, `country_id` INTEGER NOT NULL, `paypal_percentage` INTEGER NOT NULL, `paypal_fixed` INTEGER NOT NULL, `stripe_percentage` INTEGER NOT NULL, `stripe_fixed` INTEGER NOT NULL, `business_id` INTEGER NOT NULL, `other` INTEGER NOT NULL, `created_at` TEXT, `name` TEXT, `iso` TEXT, `currency_code` TEXT, PRIMARY KEY(`id`))");
        _db.execSQL("CREATE TABLE IF NOT EXISTS `CountryCom` (`id` INTEGER NOT NULL, `phone_code` TEXT, `iso` TEXT, `iso3` TEXT, `currency_name` TEXT, `currency_code` TEXT, `currency_symbol` TEXT, `image` TEXT, `created_at` TEXT, PRIMARY KEY(`id`))");
        _db.execSQL("CREATE TABLE IF NOT EXISTS room_master_table (id INTEGER PRIMARY KEY,identity_hash TEXT)");
        _db.execSQL("INSERT OR REPLACE INTO room_master_table (id,identity_hash) VALUES(42, 'daad87304b21cd97478c7321b8c1e509')");
      }

      @Override
      public void dropAllTables(SupportSQLiteDatabase _db) {
        _db.execSQL("DROP TABLE IF EXISTS `CardBrandCommission`");
        _db.execSQL("DROP TABLE IF EXISTS `CountryCommission`");
        _db.execSQL("DROP TABLE IF EXISTS `CountryCom`");
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onDestructiveMigration(_db);
          }
        }
      }

      @Override
      protected void onCreate(SupportSQLiteDatabase _db) {
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onCreate(_db);
          }
        }
      }

      @Override
      public void onOpen(SupportSQLiteDatabase _db) {
        mDatabase = _db;
        internalInitInvalidationTracker(_db);
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onOpen(_db);
          }
        }
      }

      @Override
      public void onPreMigrate(SupportSQLiteDatabase _db) {
        DBUtil.dropFtsSyncTriggers(_db);
      }

      @Override
      public void onPostMigrate(SupportSQLiteDatabase _db) {
      }

      @Override
      protected RoomOpenHelper.ValidationResult onValidateSchema(SupportSQLiteDatabase _db) {
        final HashMap<String, TableInfo.Column> _columnsCardBrandCommission = new HashMap<String, TableInfo.Column>(8);
        _columnsCardBrandCommission.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("card_brand_id", new TableInfo.Column("card_brand_id", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("business_id", new TableInfo.Column("business_id", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("stripe_percentage", new TableInfo.Column("stripe_percentage", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("stripe_fixed", new TableInfo.Column("stripe_fixed", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("other", new TableInfo.Column("other", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("created_at", new TableInfo.Column("created_at", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCardBrandCommission.put("brand_name", new TableInfo.Column("brand_name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysCardBrandCommission = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesCardBrandCommission = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoCardBrandCommission = new TableInfo("CardBrandCommission", _columnsCardBrandCommission, _foreignKeysCardBrandCommission, _indicesCardBrandCommission);
        final TableInfo _existingCardBrandCommission = TableInfo.read(_db, "CardBrandCommission");
        if (! _infoCardBrandCommission.equals(_existingCardBrandCommission)) {
          return new RoomOpenHelper.ValidationResult(false, "CardBrandCommission(com.ubsidi.menu.models.CardBrandCommission).\n"
                  + " Expected:\n" + _infoCardBrandCommission + "\n"
                  + " Found:\n" + _existingCardBrandCommission);
        }
        final HashMap<String, TableInfo.Column> _columnsCountryCommission = new HashMap<String, TableInfo.Column>(12);
        _columnsCountryCommission.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("country_id", new TableInfo.Column("country_id", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("paypal_percentage", new TableInfo.Column("paypal_percentage", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("paypal_fixed", new TableInfo.Column("paypal_fixed", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("stripe_percentage", new TableInfo.Column("stripe_percentage", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("stripe_fixed", new TableInfo.Column("stripe_fixed", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("business_id", new TableInfo.Column("business_id", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("other", new TableInfo.Column("other", "INTEGER", true, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("created_at", new TableInfo.Column("created_at", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("name", new TableInfo.Column("name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("iso", new TableInfo.Column("iso", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCommission.put("currency_code", new TableInfo.Column("currency_code", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysCountryCommission = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesCountryCommission = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoCountryCommission = new TableInfo("CountryCommission", _columnsCountryCommission, _foreignKeysCountryCommission, _indicesCountryCommission);
        final TableInfo _existingCountryCommission = TableInfo.read(_db, "CountryCommission");
        if (! _infoCountryCommission.equals(_existingCountryCommission)) {
          return new RoomOpenHelper.ValidationResult(false, "CountryCommission(com.ubsidi.menu.models.CountryCommission).\n"
                  + " Expected:\n" + _infoCountryCommission + "\n"
                  + " Found:\n" + _existingCountryCommission);
        }
        final HashMap<String, TableInfo.Column> _columnsCountryCom = new HashMap<String, TableInfo.Column>(9);
        _columnsCountryCom.put("id", new TableInfo.Column("id", "INTEGER", true, 1, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("phone_code", new TableInfo.Column("phone_code", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("iso", new TableInfo.Column("iso", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("iso3", new TableInfo.Column("iso3", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("currency_name", new TableInfo.Column("currency_name", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("currency_code", new TableInfo.Column("currency_code", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("currency_symbol", new TableInfo.Column("currency_symbol", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("image", new TableInfo.Column("image", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        _columnsCountryCom.put("created_at", new TableInfo.Column("created_at", "TEXT", false, 0, null, TableInfo.CREATED_FROM_ENTITY));
        final HashSet<TableInfo.ForeignKey> _foreignKeysCountryCom = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesCountryCom = new HashSet<TableInfo.Index>(0);
        final TableInfo _infoCountryCom = new TableInfo("CountryCom", _columnsCountryCom, _foreignKeysCountryCom, _indicesCountryCom);
        final TableInfo _existingCountryCom = TableInfo.read(_db, "CountryCom");
        if (! _infoCountryCom.equals(_existingCountryCom)) {
          return new RoomOpenHelper.ValidationResult(false, "CountryCom(com.ubsidi.menu.models.CountryCom).\n"
                  + " Expected:\n" + _infoCountryCom + "\n"
                  + " Found:\n" + _existingCountryCom);
        }
        return new RoomOpenHelper.ValidationResult(true, null);
      }
    }, "daad87304b21cd97478c7321b8c1e509", "a6bd978826e47fd5cc1537ec46d96822");
    final SupportSQLiteOpenHelper.Configuration _sqliteConfig = SupportSQLiteOpenHelper.Configuration.builder(configuration.context)
        .name(configuration.name)
        .callback(_openCallback)
        .build();
    final SupportSQLiteOpenHelper _helper = configuration.sqliteOpenHelperFactory.create(_sqliteConfig);
    return _helper;
  }

  @Override
  protected InvalidationTracker createInvalidationTracker() {
    final HashMap<String, String> _shadowTablesMap = new HashMap<String, String>(0);
    HashMap<String, Set<String>> _viewTables = new HashMap<String, Set<String>>(0);
    return new InvalidationTracker(this, _shadowTablesMap, _viewTables, "CardBrandCommission","CountryCommission","CountryCom");
  }

  @Override
  public void clearAllTables() {
    super.assertNotMainThread();
    final SupportSQLiteDatabase _db = super.getOpenHelper().getWritableDatabase();
    try {
      super.beginTransaction();
      _db.execSQL("DELETE FROM `CardBrandCommission`");
      _db.execSQL("DELETE FROM `CountryCommission`");
      _db.execSQL("DELETE FROM `CountryCom`");
      super.setTransactionSuccessful();
    } finally {
      super.endTransaction();
      _db.query("PRAGMA wal_checkpoint(FULL)").close();
      if (!_db.inTransaction()) {
        _db.execSQL("VACUUM");
      }
    }
  }

  @Override
  protected Map<Class<?>, List<Class<?>>> getRequiredTypeConverters() {
    final HashMap<Class<?>, List<Class<?>>> _typeConvertersMap = new HashMap<Class<?>, List<Class<?>>>();
    _typeConvertersMap.put(CommissionDao.class, CommissionDao_Impl.getRequiredConverters());
    return _typeConvertersMap;
  }

  @Override
  public CommissionDao commissionDao() {
    if (_commissionDao != null) {
      return _commissionDao;
    } else {
      synchronized(this) {
        if(_commissionDao == null) {
          _commissionDao = new CommissionDao_Impl(this);
        }
        return _commissionDao;
      }
    }
  }
}
