package com.ubsidi.menu.activities;

import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

import com.google.android.material.button.MaterialButton;
import com.ubsidi.menu.R;
import com.ubsidi.menu.common.CommonFunctions;
import com.ubsidi.menu.utils.LogUtils;
import com.ubsidi.menu.utils.ToastUtils;

import java.util.Timer;
import java.util.TimerTask;

public class NoInternetActivity extends AppCompatActivity {

    MaterialButton btnRefresh;
    Timer timer;
    TimerTask timerTask;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_no_internet);

        try {
            btnRefresh = findViewById(R.id.btnRefresh);

            btnRefresh.setOnClickListener(view -> {
                if (CommonFunctions.isConnected(NoInternetActivity.this)) {
                    Intent returnIntent = new Intent();
                    setResult(Activity.RESULT_OK,returnIntent);
                    finish();
                }
            });
            timer = new Timer();
            startTask();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void startTask() {
        try {
            timerTask = new TimerTask() {
                @Override
                public void run() {
                    LogUtils.e("Checking connectivity....");
                    if (CommonFunctions.isConnected(NoInternetActivity.this)) {
                        LogUtils.e("Internet connected");
                        timerTask.cancel();
                        ToastUtils.makeSnackToast(NoInternetActivity.this, "Internet connection is back");
                        runOnUiThread(() -> {
                            Intent returnIntent = new Intent();
                            setResult(Activity.RESULT_OK,returnIntent);
                            finish();
                        });

                    }
                }
            };
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void onStop() {
        if (timerTask != null)
            timerTask.cancel();
        super.onStop();
    }

    @Override
    protected void onResume() {
        super.onResume();
        try {
            if (timerTask != null) {
                startTask();
                timer.schedule(timerTask, 10000, 2000);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}