package com.ubsidi.menu.network;

import android.os.Handler;
import android.os.Looper;

import com.ubsidi.menu.MyApp;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.Map;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * Created by Amrish on 19-08-2020.
 */
public class NetworkInterceptor implements Interceptor {
    @Override
    public Response intercept(Chain chain) throws IOException {

        Request originalRequest = chain.request();
        Response response = null;
        try {
            Request.Builder tokenRequestBuilder = originalRequest.newBuilder();
            Map<String, String> headers = null;
            headers = MyApp.getInstance().getMyPreferences().getBusinessToken();
            tokenRequestBuilder.addHeader("package-name", MyApp.getInstance().getPackageName());
            if (headers != null) {
                for (Map.Entry<String, String> entry : headers.entrySet()) {
                    tokenRequestBuilder.header(entry.getKey(), entry.getValue());
                }
            }

            response = chain.proceed(tokenRequestBuilder.build());
            String xToken = response.header("x-token", null);
            String xRefreshToken = response.header("x-refresh-token", null);
            if (xToken != null && xRefreshToken != null) {
                MyApp.getInstance().getMyPreferences().saveBusinessToken(xToken, xRefreshToken);
            }
        } catch (UnknownHostException e) {

            new Handler(Looper.getMainLooper())
                    .post(() -> {
//                        ToastUtils.makeToast(MyApp.getInstance().getApplicationContext(), "No internet connection");
//                        MyApp.getInstance().getApplicationContext().startActivity(new Intent(MyApp.getInstance().getApplicationContext(), NoInternetActivity.class).setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP));
                    });
            throw e;
        } catch (IOException e) {
            e.printStackTrace();

            new Handler(Looper.getMainLooper())
                    .post(() -> {
//                        ToastUtils.makeToast(MyApp.getInstance().getApplicationContext(), "No internet connection");
//                        MyApp.getInstance().getApplicationContext().startActivity(new Intent(MyApp.getInstance().getApplicationContext(), NoInternetActivity.class).setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP));
                    });
//                            Toast.makeText(myApp.getApplicationContext(),
//                            "No internet connection!", Toast.LENGTH_SHORT).show());
            throw e;
        }

        return response;
    }
}
