package com.ubsidi.menu.dao;

import android.database.Cursor;
import androidx.room.EntityInsertionAdapter;
import androidx.room.RoomDatabase;
import androidx.room.RoomSQLiteQuery;
import androidx.room.SharedSQLiteStatement;
import androidx.room.util.CursorUtil;
import androidx.room.util.DBUtil;
import androidx.sqlite.db.SupportSQLiteStatement;
import com.ubsidi.menu.models.CardBrandCommission;
import com.ubsidi.menu.models.CountryCommission;
import java.lang.Class;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

@SuppressWarnings({"unchecked", "deprecation"})
public final class CommissionDao_Impl implements CommissionDao {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter<CardBrandCommission> __insertionAdapterOfCardBrandCommission;

  private final EntityInsertionAdapter<CountryCommission> __insertionAdapterOfCountryCommission;

  private final SharedSQLiteStatement __preparedStmtOfNukeCountryCommission;

  private final SharedSQLiteStatement __preparedStmtOfNukeCardBrandCommission;

  public CommissionDao_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfCardBrandCommission = new EntityInsertionAdapter<CardBrandCommission>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `CardBrandCommission` (`id`,`card_brand_id`,`business_id`,`stripe_percentage`,`stripe_fixed`,`other`,`created_at`,`brand_name`) VALUES (?,?,?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, CardBrandCommission value) {
        stmt.bindLong(1, value.id);
        stmt.bindLong(2, value.card_brand_id);
        stmt.bindLong(3, value.business_id);
        stmt.bindLong(4, value.stripe_percentage);
        stmt.bindLong(5, value.stripe_fixed);
        final int _tmp;
        _tmp = value.other ? 1 : 0;
        stmt.bindLong(6, _tmp);
        if (value.created_at == null) {
          stmt.bindNull(7);
        } else {
          stmt.bindString(7, value.created_at);
        }
        if (value.brand_name == null) {
          stmt.bindNull(8);
        } else {
          stmt.bindString(8, value.brand_name);
        }
      }
    };
    this.__insertionAdapterOfCountryCommission = new EntityInsertionAdapter<CountryCommission>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR REPLACE INTO `CountryCommission` (`id`,`country_id`,`paypal_percentage`,`paypal_fixed`,`stripe_percentage`,`stripe_fixed`,`business_id`,`other`,`created_at`,`name`,`iso`,`currency_code`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, CountryCommission value) {
        stmt.bindLong(1, value.id);
        stmt.bindLong(2, value.country_id);
        stmt.bindLong(3, value.paypal_percentage);
        stmt.bindLong(4, value.paypal_fixed);
        stmt.bindLong(5, value.stripe_percentage);
        stmt.bindLong(6, value.stripe_fixed);
        stmt.bindLong(7, value.business_id);
        final int _tmp;
        _tmp = value.other ? 1 : 0;
        stmt.bindLong(8, _tmp);
        if (value.created_at == null) {
          stmt.bindNull(9);
        } else {
          stmt.bindString(9, value.created_at);
        }
        if (value.name == null) {
          stmt.bindNull(10);
        } else {
          stmt.bindString(10, value.name);
        }
        if (value.iso == null) {
          stmt.bindNull(11);
        } else {
          stmt.bindString(11, value.iso);
        }
        if (value.currency_code == null) {
          stmt.bindNull(12);
        } else {
          stmt.bindString(12, value.currency_code);
        }
      }
    };
    this.__preparedStmtOfNukeCountryCommission = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM CountryCommission";
        return _query;
      }
    };
    this.__preparedStmtOfNukeCardBrandCommission = new SharedSQLiteStatement(__db) {
      @Override
      public String createQuery() {
        final String _query = "DELETE FROM CardBrandCommission";
        return _query;
      }
    };
  }

  @Override
  public void insertCardBrands(final List<CardBrandCommission> cardBrandCommissions) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfCardBrandCommission.insert(cardBrandCommissions);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void insertCountryCommissions(final List<CountryCommission> countryCommissions) {
    __db.assertNotSuspendingTransaction();
    __db.beginTransaction();
    try {
      __insertionAdapterOfCountryCommission.insert(countryCommissions);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void nukeCountryCommission() {
    __db.assertNotSuspendingTransaction();
    final SupportSQLiteStatement _stmt = __preparedStmtOfNukeCountryCommission.acquire();
    __db.beginTransaction();
    try {
      _stmt.executeUpdateDelete();
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
      __preparedStmtOfNukeCountryCommission.release(_stmt);
    }
  }

  @Override
  public void nukeCardBrandCommission() {
    __db.assertNotSuspendingTransaction();
    final SupportSQLiteStatement _stmt = __preparedStmtOfNukeCardBrandCommission.acquire();
    __db.beginTransaction();
    try {
      _stmt.executeUpdateDelete();
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
      __preparedStmtOfNukeCardBrandCommission.release(_stmt);
    }
  }

  @Override
  public List<CardBrandCommission> listBrand() {
    final String _sql = "SELECT * FROM CardBrandCommission";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
      final int _cursorIndexOfCardBrandId = CursorUtil.getColumnIndexOrThrow(_cursor, "card_brand_id");
      final int _cursorIndexOfBusinessId = CursorUtil.getColumnIndexOrThrow(_cursor, "business_id");
      final int _cursorIndexOfStripePercentage = CursorUtil.getColumnIndexOrThrow(_cursor, "stripe_percentage");
      final int _cursorIndexOfStripeFixed = CursorUtil.getColumnIndexOrThrow(_cursor, "stripe_fixed");
      final int _cursorIndexOfOther = CursorUtil.getColumnIndexOrThrow(_cursor, "other");
      final int _cursorIndexOfCreatedAt = CursorUtil.getColumnIndexOrThrow(_cursor, "created_at");
      final int _cursorIndexOfBrandName = CursorUtil.getColumnIndexOrThrow(_cursor, "brand_name");
      final List<CardBrandCommission> _result = new ArrayList<CardBrandCommission>(_cursor.getCount());
      while(_cursor.moveToNext()) {
        final CardBrandCommission _item;
        _item = new CardBrandCommission();
        _item.id = _cursor.getInt(_cursorIndexOfId);
        _item.card_brand_id = _cursor.getInt(_cursorIndexOfCardBrandId);
        _item.business_id = _cursor.getInt(_cursorIndexOfBusinessId);
        _item.stripe_percentage = _cursor.getInt(_cursorIndexOfStripePercentage);
        _item.stripe_fixed = _cursor.getInt(_cursorIndexOfStripeFixed);
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfOther);
        _item.other = _tmp != 0;
        if (_cursor.isNull(_cursorIndexOfCreatedAt)) {
          _item.created_at = null;
        } else {
          _item.created_at = _cursor.getString(_cursorIndexOfCreatedAt);
        }
        if (_cursor.isNull(_cursorIndexOfBrandName)) {
          _item.brand_name = null;
        } else {
          _item.brand_name = _cursor.getString(_cursorIndexOfBrandName);
        }
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  @Override
  public List<CountryCommission> listCountry() {
    final String _sql = "SELECT * FROM CountryCommission";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    __db.assertNotSuspendingTransaction();
    final Cursor _cursor = DBUtil.query(__db, _statement, false, null);
    try {
      final int _cursorIndexOfId = CursorUtil.getColumnIndexOrThrow(_cursor, "id");
      final int _cursorIndexOfCountryId = CursorUtil.getColumnIndexOrThrow(_cursor, "country_id");
      final int _cursorIndexOfPaypalPercentage = CursorUtil.getColumnIndexOrThrow(_cursor, "paypal_percentage");
      final int _cursorIndexOfPaypalFixed = CursorUtil.getColumnIndexOrThrow(_cursor, "paypal_fixed");
      final int _cursorIndexOfStripePercentage = CursorUtil.getColumnIndexOrThrow(_cursor, "stripe_percentage");
      final int _cursorIndexOfStripeFixed = CursorUtil.getColumnIndexOrThrow(_cursor, "stripe_fixed");
      final int _cursorIndexOfBusinessId = CursorUtil.getColumnIndexOrThrow(_cursor, "business_id");
      final int _cursorIndexOfOther = CursorUtil.getColumnIndexOrThrow(_cursor, "other");
      final int _cursorIndexOfCreatedAt = CursorUtil.getColumnIndexOrThrow(_cursor, "created_at");
      final int _cursorIndexOfName = CursorUtil.getColumnIndexOrThrow(_cursor, "name");
      final int _cursorIndexOfIso = CursorUtil.getColumnIndexOrThrow(_cursor, "iso");
      final int _cursorIndexOfCurrencyCode = CursorUtil.getColumnIndexOrThrow(_cursor, "currency_code");
      final List<CountryCommission> _result = new ArrayList<CountryCommission>(_cursor.getCount());
      while(_cursor.moveToNext()) {
        final CountryCommission _item;
        _item = new CountryCommission();
        _item.id = _cursor.getInt(_cursorIndexOfId);
        _item.country_id = _cursor.getInt(_cursorIndexOfCountryId);
        _item.paypal_percentage = _cursor.getInt(_cursorIndexOfPaypalPercentage);
        _item.paypal_fixed = _cursor.getInt(_cursorIndexOfPaypalFixed);
        _item.stripe_percentage = _cursor.getInt(_cursorIndexOfStripePercentage);
        _item.stripe_fixed = _cursor.getInt(_cursorIndexOfStripeFixed);
        _item.business_id = _cursor.getInt(_cursorIndexOfBusinessId);
        final int _tmp;
        _tmp = _cursor.getInt(_cursorIndexOfOther);
        _item.other = _tmp != 0;
        if (_cursor.isNull(_cursorIndexOfCreatedAt)) {
          _item.created_at = null;
        } else {
          _item.created_at = _cursor.getString(_cursorIndexOfCreatedAt);
        }
        if (_cursor.isNull(_cursorIndexOfName)) {
          _item.name = null;
        } else {
          _item.name = _cursor.getString(_cursorIndexOfName);
        }
        if (_cursor.isNull(_cursorIndexOfIso)) {
          _item.iso = null;
        } else {
          _item.iso = _cursor.getString(_cursorIndexOfIso);
        }
        if (_cursor.isNull(_cursorIndexOfCurrencyCode)) {
          _item.currency_code = null;
        } else {
          _item.currency_code = _cursor.getString(_cursorIndexOfCurrencyCode);
        }
        _result.add(_item);
      }
      return _result;
    } finally {
      _cursor.close();
      _statement.release();
    }
  }

  public static List<Class<?>> getRequiredConverters() {
    return Collections.emptyList();
  }
}
