package com.ubsidi.menu.adapters;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Filter;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.ubsidi.menu.R;
import com.ubsidi.menu.common.Validators;
import com.ubsidi.menu.models.AddSubAddon;

import java.util.ArrayList;
import java.util.List;

public class AddonAutoSuggestedAdapter extends ArrayAdapter<AddSubAddon> {

    List<AddSubAddon> items, tempItems, suggestions;
    private Activity activity;
    private String mainaddons_name;
    private String name;

    public AddonAutoSuggestedAdapter(@NonNull Activity context, List<AddSubAddon> items, String mainaddon_name) {
        super(context, 0, items);
        this.activity = context;
        this.items = items;
        this.mainaddons_name = mainaddon_name;
        tempItems = new ArrayList<AddSubAddon>(items); // this makes the difference.
        suggestions = new ArrayList<AddSubAddon>();
    }

    public void updateData(List<AddSubAddon> items) {
        this.items = items;
        tempItems = new ArrayList<AddSubAddon>(items); // this makes the difference.
        if (activity != null) {
            activity.runOnUiThread(this::notifyDataSetChanged);
        }
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.custom_auto_text_layout, parent, false);
        }
        TextView tvCustomer = convertView.findViewById(R.id.tvCategoryName);

        AddSubAddon subAddon = items.get(position);

        tvCustomer.setText(mainaddons_name + "- " + subAddon.subaddons_name);
        return convertView;
    }

    @NonNull
    @Override
    public Filter getFilter() {
        return nameFilter;
    }

    Filter nameFilter = new Filter() {
        @Override
        public CharSequence convertResultToString(Object resultValue) {
            String str = mainaddons_name + "- " + ((AddSubAddon) resultValue).subaddons_name;
            return str;
        }

        @Override
        protected FilterResults performFiltering(CharSequence constraint) {
            if (activity != null) {
                activity.runOnUiThread(() -> {

                });
            }
            if (constraint != null) {
                suggestions.clear();
                int count = 0;
                for (AddSubAddon addon : tempItems) {
                    if ((!Validators.isNullOrEmpty(mainaddons_name) && mainaddons_name.toLowerCase().contains(constraint.toString().toLowerCase())) || ((addon.subaddons_name != null && addon.subaddons_name.toLowerCase().contains(constraint.toString().toLowerCase())))) {
                        suggestions.add(addon);
                        count++;
                        if (count == 25) {
                            break;
                        }
                    }
                }
                FilterResults filterResults = new FilterResults();
                filterResults.values = suggestions;
                filterResults.count = suggestions.size();
                return filterResults;
            } else {
                return new FilterResults();
            }
        }

        @Override
        protected void publishResults(CharSequence constraint, FilterResults results) {
            if (activity != null) {
                activity.runOnUiThread(() -> {
                    List<AddSubAddon> filterList = (ArrayList<AddSubAddon>) results.values;
                    if (results != null && results.count > 0) {
                        clear();
                        addAll(filterList);
                        notifyDataSetChanged();
                    }

                });
            }
        }
    };
}
