package com.ubsidi.menu.base;

import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import com.ubsidi.menu.MyApp;
import com.ubsidi.menu.common.CommonFunctions;
import com.ubsidi.menu.models.Merchant;
import com.ubsidi.menu.models.MerchantBusinesses;
import com.ubsidi.menu.models.RestaurantUser;
import com.ubsidi.menu.utils.LogUtils;

/**
 * Created by admin on 14-03-2017.
 */

public class BaseActivity extends AppCompatActivity {

    protected MyApp myApp = MyApp.getInstance();
    protected AlertDialog progressDialog;
    protected RestaurantUser loggedInRestaurant;
    protected Merchant loggedInMerchant;
    protected MerchantBusinesses merchantBusinesses;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        manageIntents();
        setXML();
        initViews();
    }

    protected void manageIntents() {
        Bundle bundle = getIntent().getExtras();
        if (bundle != null) {
            for (String key : bundle.keySet()) {
                LogUtils.w("##EXTRAS##", key + " : " + (bundle.get(key) != null ? bundle.get(key) : "NULL"));
            }
        }
    }

    protected void setXML() {

    }

    protected void initViews() {
        loggedInRestaurant = myApp.getMyPreferences().getLoggedInRestaurant();
        loggedInMerchant = myApp.getMyPreferences().getLoggedInMerchant();
        merchantBusinesses = myApp.getMyPreferences().getMerchantBusinesses();
        if (loggedInMerchant != null && merchantBusinesses != null && !merchantBusinesses.merchant_service)
            loggedInMerchant = null;
        if (loggedInMerchant != null && merchantBusinesses == null) loggedInMerchant = null;
        progressDialog = CommonFunctions.customProgressDialog(this, "Loading...");
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return super.onSupportNavigateUp();
    }

    /*// Nougat related issue from Firebase
    @Override
    protected void onSaveInstanceState(Bundle oldInstanceState) {
        super.onSaveInstanceState(oldInstanceState);
        oldInstanceState.clear();
    }*/
}
