package com.ubsidi.menu.fragments;

import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;

import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.ParsedRequestListener;
import com.google.android.material.button.MaterialButton;
import com.google.android.material.textfield.MaterialAutoCompleteTextView;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.ubsidi.menu.R;
import com.ubsidi.menu.adapters.AddonAutoSuggestedAdapter;
import com.ubsidi.menu.adapters.SubAddonPriceAdapter;
import com.ubsidi.menu.base.BaseBottomSheet;
import com.ubsidi.menu.base.BaseFragment;
import com.ubsidi.menu.common.Validators;
import com.ubsidi.menu.interfaces.DialogDismissListener;
import com.ubsidi.menu.models.AddAddon;
import com.ubsidi.menu.models.AddMainAddon;
import com.ubsidi.menu.models.AddSubAddon;
import com.ubsidi.menu.models.Header;
import com.ubsidi.menu.models.SubAddon;
import com.ubsidi.menu.models.Variants;
import com.ubsidi.menu.network.ApiEndPoints;
import com.ubsidi.menu.utils.LogUtils;
import com.ubsidi.menu.utils.ToastUtils;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class AddProductSubAddonBottomSheetFragment extends BaseBottomSheet {

    private DialogDismissListener dialogDismissListener;
    private MaterialAutoCompleteTextView etSubAddon;
    private RecyclerView rvPrice;
    private MaterialButton btnCancel, btnConfirm;
    private SubAddonPriceAdapter addonPriceAdapter;
    private ArrayList<Header> priceCount = new ArrayList<>();
    private ArrayList<Header> selectedPriceList = new ArrayList<>();
    private ArrayList<AddSubAddon> subAddons = new ArrayList<>();
    private ArrayList<Variants> priceVariant = new ArrayList<>();
    private ArrayAdapter<AddSubAddon> autoadapter;
    private ArrayList<AddMainAddon> mainAddons = new ArrayList<>();
    private int selectedAddonId = -1, selectedCategoryId = -1;
    private ArrayList<AddSubAddon> selectedSubAddon = new ArrayList<>();

    public static AddProductSubAddonBottomSheetFragment getInstance(ArrayList<Variants> priceVariant, int selectedCategoryId) {
        AddProductSubAddonBottomSheetFragment feedbackSubjectBottomSheetFragment = new AddProductSubAddonBottomSheetFragment();
        Bundle bundle = new Bundle();
        bundle.putString("price_variants", new Gson().toJson(priceVariant));
        bundle.putInt("selected_categoryId", selectedCategoryId);
        feedbackSubjectBottomSheetFragment.setArguments(bundle);
        return feedbackSubjectBottomSheetFragment;
    }

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_add_product_sub_addon_bottom_sheet, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        fetchAddons();
        updateViews();
    }

    @Override
    protected void setListeners() {
        super.setListeners();
        btnCancel.setOnClickListener(view -> dismiss());

        btnConfirm.setOnClickListener(view -> {
                    LogUtils.e("selectedPriceList: " + selectedPriceList.size());
                    LogUtils.e("priceCount: " + priceCount.size());

                    if (Validators.isNullOrEmpty(etSubAddon.getText().toString())) {
                        ToastUtils.makeToast(getActivity(), "Please select addon name");
                    } else if (selectedPriceList.size() == 0 || selectedPriceList.size() != priceCount.size()) {
                        ToastUtils.makeToast(getActivity(), "Please add price");
                    } else {
                        AddMainAddon mainAddon = new AddMainAddon();
                        LogUtils.e("Main addons size: " + mainAddons.size());
                        LogUtils.e("Sub addons size: " + mainAddons.get(0).sub_addonses.size());
                        LogUtils.e("Sub addons size: " + subAddons.size());
                        subAddons.clear();
                        subAddons.addAll(mainAddons.get(0).sub_addonses);
                        for (AddMainAddon addon : mainAddons) {
                            for (AddSubAddon subAddon : subAddons) {
                                if (subAddon.id == selectedAddonId) {
                                    subAddon.selected = true;
                                } else {
                                    subAddon.selected = false;
                                }
                                mainAddon = addon;
                                mainAddon.sub_addonses.clear();
                                mainAddon.sub_addonses.addAll(subAddons);
                                mainAddon.priceList.clear();
                                mainAddon.priceList.addAll(selectedPriceList);
                            }
                        }
                        AddMainAddon mainAddon1 = new AddMainAddon();
                        for (AddMainAddon addon : mainAddons) {
                            for (int a = 0; a < selectedPriceList.size(); a++) {
                                for (int i = 0; i < subAddons.size(); i++) {
                                    if (subAddons.get(i).id == selectedAddonId) {
                                        AddSubAddon subAddon = new AddSubAddon();
                                        subAddon.id = subAddons.get(i).id;
                                        subAddon.mainaddons_id = subAddons.get(i).mainaddons_id;
                                        subAddon.selected = true;
                                        subAddon.subaddons_price = selectedPriceList.get(a).title;
                                        subAddon.subaddons_name = subAddons.get(i).subaddons_name;
                                        mainAddon1.sub_addonses.add(subAddon);
//                                        mainAddon1 = addon;
//                                } else {
//                                    subAddon.selected = false;
                                    }
//                                mainAddon1.sub_addonses.clear();
//                                mainAddon1.sub_addonses.addAll(subAddons);
//                                mainAddon1.priceList.clear();
//                                mainAddon1.priceList.addAll(selectedPriceList);
                                }
                            }
                            mainAddon1 = addon;
                        }
                        LogUtils.d("selected sub Addon::" + new Gson().toJson(mainAddon1));
                        if (dialogDismissListener != null)
//                            dialogDismissListener.onDialogDismiss(mainAddon);
//                            dialogDismissListener.onDialogDismiss(mainAddon1);
                            dialogDismissListener.onDialogDismiss(mainAddon);
                        dismiss();
//                        LogUtils.e("selected sub Addon::" + new Gson().toJson(mainAddon));
                    }
                }
        );
    }

    private void updateViews() {
        if (priceVariant.size() != 0) {
            priceCount.clear();
            for (int i = 1; i <= priceVariant.size(); i++) {
                Header header = new Header();
                header.total = "Price " + i;
                priceCount.add(header);
            }
            addonPriceAdapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void manageIntents() {
        super.manageIntents();
        if (getArguments() != null) {
            Type type = new TypeToken<List<Variants>>() {
            }.getType();
            priceVariant = new Gson().fromJson(getArguments().getString("price_variants"), type);
            selectedCategoryId = getArguments().getInt("selected_categoryId");
        }

        LogUtils.e("Price Variant selected::" + new Gson().toJson(priceVariant));
    }

    @Override
    protected void initViews(View view) {
        super.initViews(view);
        etSubAddon = view.findViewById(R.id.autoSubAddon);
        rvPrice = view.findViewById(R.id.rvPrice);
        btnCancel = view.findViewById(R.id.btnCancel);
        btnConfirm = view.findViewById(R.id.btnConfirm);

        etSubAddon.setOnItemClickListener((adapterView, view1, i, l) -> {
            int indext = subAddons.indexOf(adapterView.getItemAtPosition(i));
            if (indext != -1) {
                selectedAddonId = subAddons.get(indext).id;
                //LogUtils.e("Category name is::" + addons.get(indext).category_name + "and id::" + selectedCategoryId);
            }

        });


        addonPriceAdapter = new SubAddonPriceAdapter(priceCount, (position, data) -> {
            Header price = (Header) data;
            selectedPriceList.add(price);
        });
        rvPrice.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));
        rvPrice.setAdapter(addonPriceAdapter);
    }

    private void fetchAddons() {
        try {
            AndroidNetworking.get(ApiEndPoints.online_addons + selectedCategoryId)
                    .addHeaders("restaurant_id", myApp.getMyPreferences().getMerchantBusinesses().restaurant_id)
                    .addQueryParameter("nopaginate", "1")
                    .build()
                    .getAsObject(AddMainAddon.class, new ParsedRequestListener<AddMainAddon>() {
                        @Override
                        public void onResponse(AddMainAddon response) {
                            try {
                                mainAddons.clear();
                                mainAddons.add(response);
                                subAddons.clear();
                                subAddons.addAll(response.sub_addonses);
                                etSubAddon.setThreshold(1);
                                autoadapter = new AddonAutoSuggestedAdapter(getActivity(), subAddons, response.mainaddons_name);
                                etSubAddon.setAdapter(autoadapter);

                                LogUtils.e("AddMainAddon::" + new Gson().toJson(response));
                                LogUtils.e("subAddons size::" + subAddons.size());
                                LogUtils.e("subAddons::" + new Gson().toJson(subAddons));
                            } catch (Exception e) {
                                e.printStackTrace();
                            }

                        }

                        @Override
                        public void onError(ANError anError) {
                            try {
                                anError.printStackTrace();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }

                        }
                    });
        } catch (Exception e) {
            e.printStackTrace();

        }

    }
}